var adhiyan_selEnc;

if(adhiyan_selEnc == null)
	adhiyan_selEnc = "english";

function adhiyan_setEnc(enc)
{
	adhiyan_selEnc = enc;
}

function adhiyan_getArray(enc)
{
   var retArr;
   switch (enc)
   {
         case "che":   retArr = che;break;
         case "eng":   retArr = eng;break;
         case "tsc":   retArr = tsc;break;
         case "tun":   retArr = tun;break;
         case "asc":   retArr = asc;break;
         case "tab":   retArr = tab;break;
         case "tam":   retArr = tam;break;
         case "tha":   retArr = tha;break;
         case "man":   retArr = man;break;
         case "kam":   retArr = kam;break;
         case "kal":   retArr = kal;break;
         default: retArr = new Array(); break;
   }   
   return retArr;
}

function adhiyan_convEnc(txt)
{
	if(adhiyan_checkEng(txt)  && adhiyan_selEnc != "kalaham" )
		return txt;
	var txtarr = adhiyan_getArray(adhiyan_selEnc.substring(0,3));
	if(txtarr.length == 0)
		return txt;
	txt = adhiyan_align(adhiyan_selEnc,txt);
	for(itm in txtarr)
	{
		var mychar = String.fromCharCode(itm);
		if(isNaN(itm))
			mychar = itm;
		if(mychar == '[' || mychar == ']' || mychar == '('
		|| mychar == ')' || mychar == '{' || mychar == '}'
		|| mychar == '^' || mychar == '$' || mychar == '|'
		|| mychar == '.' || mychar == '+' || mychar == '?'
		|| mychar == '*' || mychar == '/' || mychar == ':'
		|| mychar == '\\' )
			mychar = '\\'+mychar;
		var rexp = new RegExp(mychar,"g");
		txt = txt.replace(rexp, txtarr[itm]);
	}
	txt = adhiyan_canonicalFix(txt);
	return txt;
}

function adhiyan_canonicalFix(txt)
{
	var mychar = "\u0BC6\u0BBE"; //ogara otru
	var rexp = new RegExp(mychar,"g");
	txt = txt.replace(rexp, "\u0BCA");

	mychar = "\u0BC7\u0BBE"; //Ogaara otru
	rexp = new RegExp(mychar,"g");
	txt = txt.replace(rexp, "\u0BCB");

	//do not convert augara uyir for tscii
	if(adhiyan_selEnc != "tscii")
	{
		mychar = "\u0BC6\u0BB3"; //augaara otru
		rexp = new RegExp(mychar,"g");
		txt = txt.replace(rexp, "\u0BCC");

		mychar = "\u0B92\u0BB3"; //augara uyir
		rexp = new RegExp(mychar,"g");
		txt = txt.replace(rexp, "\u0B94");
	}
	else
	{
		//handle augaara otru for tscii
		mychar = "\u0BC6\u0BD7"; //augaara otru
		rexp = new RegExp(mychar,"g");
		txt = txt.replace(rexp, "\u0BCC");
	}

	// re-split egaram + ragaram + otru
	mychar = "\u0BCA([\u0BBE|\u0BBF|\u0BC0|\u0BC1|\u0BC2|\u0BC6|\u0BC7|\u0BC8|\u0BCA|\u0BCB|\u0BCC|\u0BCD])";
	rexp = new RegExp(mychar,"g");
	txt = txt.replace(rexp, "\u0BC6\u0BB0$1");

	// re-split Egaaram + ragaram + otru
	mychar = "\u0BCB([\u0BBE|\u0BBF|\u0BC0|\u0BC1|\u0BC2|\u0BC6|\u0BC7|\u0BC8|\u0BCA|\u0BCB|\u0BCC|\u0BCD])";
	var rexp = new RegExp(mychar,"g");
	txt = txt.replace(rexp, "\u0BC7\u0BB0$1");

	//do not re-split augara uyir or otru for tscii
	if(adhiyan_selEnc != "tscii")
	{
		// re-split egaram + lagaram + otru
		mychar = "\u0BCC([\u0BBE|\u0BBF|\u0BC0|\u0BC1|\u0BC2|\u0BC6|\u0BC7|\u0BC8|\u0BCA|\u0BCB|\u0BCC|\u0BCD])";
		var rexp = new RegExp(mychar,"g");
		txt = txt.replace(rexp, "\u0BC6\u0BB3$1");

		// re-split ogaram + lagaram + otru
		mychar = "\u0B94([\u0BBE|\u0BBF|\u0BC0|\u0BC1|\u0BC2|\u0BC6|\u0BC7|\u0BC8|\u0BCA|\u0BCB|\u0BCC|\u0BCD])";
		var rexp = new RegExp(mychar,"g");
		txt = txt.replace(rexp, "\u0B92\u0BB3$1");
	}
	// make aagaara otru + otru = ragaram + otru
	mychar = "\u0BBE([\u0BBF|\u0BC0|\u0BC1|\u0BC2|\u0BCD])";
	rexp = new RegExp(mychar,"g");
	txt = txt.replace(rexp, "\u0BB0$1");

	//join ugaram + ugaram = uugaram
	txt = txt.replace("\u0BC1\u0BC1", "\u0BC2");

	//join ugaram + aagara kaal = uugaram
	txt = txt.replace("\u0BC1\u0BBE", "\u0BC2");

   if(adhiyan_selEnc == "kalaham")
	{
		rexp = new RegExp(">","g");txt = txt.replace(rexp, '\uFE50');
		rexp = new RegExp("F","g");txt = txt.replace(rexp, '\u0B95\u0BC1');
		rexp = new RegExp("G","g");txt = txt.replace(rexp, '\u0BAA\u0BC1');
	}

	return txt;
}
function adhiyan_align(enc,txt)
{
   retTxt = ""
   switch(enc)
   {
         case "english":   retTxt = txt;	break;
         case "tscii":  	retTxt = adhiyan_alignTSCII(txt);break;
         case "tune":		retTxt = adhiyan_alignTUNE(txt);break;
         case "asc":		   retTxt = adhiyan_alignASC(txt);break;
         case "tab":		   retTxt = adhiyan_alignTAB(txt);break;
         case "tam":		   retTxt = adhiyan_alignTAM(txt);break;
         case "thanthi":	retTxt = adhiyan_alignTHANTHI(txt);break;
         case "mani":		retTxt = adhiyan_alignMANI(txt);break;
         case "chenet":		retTxt = adhiyan_alignCHENET(txt);break;
         case "kambar":		retTxt = adhiyan_alignKAMBAR(txt);break;
         case "kalaham":	retTxt = adhiyan_alignKALAHAM(txt);break;
         default: 			break;         
   }
   return retTxt;
}

function adhiyan_alignTSCII(txt)
{
	txt = adhiyan_alignOrder(txt,166);
	txt = adhiyan_alignOrder(txt,167);
	txt = adhiyan_alignOrder(txt,168);
	txt = adhiyan_alignOrder(txt,338);
	return txt;
}

function adhiyan_alignTAM(txt)
{
	txt = adhiyan_alignOrder(txt,170);
	txt = adhiyan_alignOrder(txt,171);
	txt = adhiyan_alignOrder(txt,172);
	return txt;
}

function adhiyan_alignTAB(txt)
{
	txt = adhiyan_alignOrder(txt,170);
	txt = adhiyan_alignOrder(txt,171);
	txt = adhiyan_alignOrder(txt,172);
	return txt;
}

function adhiyan_alignTUNE(txt)	{	return txt;	} //dummy
function adhiyan_alignASC(txt)	{	return txt;	} //dummy
function adhiyan_alignTHANTHI(txt)
{
	txt = adhiyan_alignOrder(txt,217);
	txt = adhiyan_alignOrder(txt,218);
	txt = adhiyan_alignOrder(txt,219);
	return txt;
}
function adhiyan_alignMANI(txt)
{
	txt = adhiyan_alignOrder(txt,249);
	txt = adhiyan_alignOrder(txt,250);
	txt = adhiyan_alignOrder(txt,251);
	return txt;
}

function adhiyan_alignCHENET(txt)
{
	txt = adhiyan_alignOrder(txt,249);
	txt = adhiyan_alignOrder(txt,250);
	txt = adhiyan_alignOrder(txt,251);
	return txt;
}

function adhiyan_alignKAMBAR(txt)
{
	txt = adhiyan_alignOrder(txt,188);
	txt = adhiyan_alignOrder(txt,216);
	txt = adhiyan_alignOrder(txt,231);
	return txt;
}

function adhiyan_alignKALAHAM(txt)
{
	txt = adhiyan_alignOrder(txt,105);
	txt = adhiyan_alignOrder(txt,78);
	txt = adhiyan_alignOrder(txt,110);
	return txt;
}

function adhiyan_alignOrder(txt,charcode)
{
	var mychar = String.fromCharCode(charcode);
	var rexp = new RegExp(mychar+"(.)","g");
	txt = txt.replace(rexp, "$1"+mychar);
	return txt;
}

function adhiyan_checkEng(str)
{
	str = adhiyan_trim(str);
	retval = true;
	seedlen = str.length
	str = str.substring(0,seedlen)
	//verify all chars are in english
	for(i=0;i<seedlen;i++)
	{
		strcd = str[i].charCodeAt(0);
		retval = retval && ( (strcd <= 122 && strcd >= 32) || strcd == 10 || strcd == 13
					|| strcd == 169 || strcd == 174 || strcd == 153 || strcd == 8220
					|| strcd == 8221 || strcd == 8211);
	}
	return retval;
}